import 'package:get/get.dart';
import 'package:get_storage/get_storage.dart';

class RxStorage<T> extends Rx<T> {
  late ReadWriteValue<String> storage;
  String Function(T model) encoder;
  T? Function(String json) decoder;

  RxStorage({
    required String key,
    required T defaultValue,
    required this.encoder,
    required this.decoder,
  }) : super(defaultValue) {
    storage = ReadWriteValue(
      key,
      encoder(defaultValue),
    );
    value = decoder(storage.val) ?? defaultValue;
  }

  @override
  set value(T val) {
    storage.val = encoder(val);
    super.value = val;
  }
}
